/*All the following examples are 
derived from :
http://processing.org/reference/libraries/pdf/index.html
these demos are not exhaustive

all PDFs made in processing are editable as vector files
in adobe illustrator.

furthermore, if you spend some time cleaning up your paths,
you can create laser cuttable shapes!

The following instructions apply specifically to the 3D lab
across from Wean where the ID students do stuff...

"we have an Epilog Legend 75. 
It is 75 watts and has a 24" x 36" bed. EPS or AI
files would be preferred and line weights should be .001" (.01pt)."

generally, if you want to laser cut out of illustrator, you'll need to talk to a
shop tech to get the exact requiments of your file as each laser cutter
works differently. The take home is that any processing drawing can theoretically
be transformed into a physical artifact throught the magic of laser cutting!

this example records frames cumulatively into one PDF by calling beginRecord in
setup()
and endRecord() in a keypress...please be aware that this process creates
a lot of vector paths very quickly (ie. i crashed illustrator in class)

question: how could you make a pdf record fifty frames?
*/


import processing.pdf.*;

void setup() {
  size(400, 400);
  smooth();
  beginRecord(PDF, "everything.pdf");
}

void draw() {
  // Be sure not to call background, otherwise your file
  // will just accumulate lots of mess, only to become invisible
   
  // Draw something good here
  if (frameCount > 100)
  ellipse(mouseX, mouseY, 100,100);
}

void keyPressed() {
  if (key == 'q') {
    endRecord();
    exit();
  }
}
